$chip(6502)
$title(Impossible Mission 2)
$paginate
$indent=8
**********************************************
*					     *
*	      Main code 		     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	setroom,prmsec,setrob
	EXTERN	wr_main, wr_aux, rd_main, rd_aux
	EXTERN	spr_1
	EXTERN	sp_poin
	EXTERN	tablee,staani
	extern	dorkimg(page0),dorknim(page0)
	extern	dorkx(page0),dorky(page0),dorksta(page0)
	extern	lifts
	extern	collide(page0),onlift(page0),liftnum(page0)
	extern	level(page0),side(page0)
	extern	corribui(page0),clear,display(page0)
	extern	workon,insrch(page0),tower16(page0),walkway
	extern	room_p,build,copy_e,lbflg(page0),last_room_data
	extern	unbuild,rebuild,darken,set_dhires,fatalfall,total_pins

	extern	footstep,scream,get_tower_data,unlock_flag,pins,pinpos

	extern	drkflg,rooms,corpin,bombtime

	extern	walkway,tower16,timer,musics,towrcomp,total_pins,tbomb,mine
	extern	lightblb,rstlft,mvflr,unplug,sounds
	extern	clrhid,enthid,dotbomb
	extern	random
	extern	save_game
	extern	initflg
	extern	bulbflg,bombmem

	public	entryx,entryy
	SEG	PAGE0

	single	anitmp		;temp - mainly for collision info
	single	anitmp1 	;temp - mainly for collision info
	double	punt
	double	restptr
	single	entryx
	single	entryy
	single	lvltmp
	single	deferfall

	SEG	maincode

;**************************************************************************
;*	ANIMATION PROCESSING
;**************************************************************************
;	Generally, the program simply uses the next animation frame data
;	as modified by the joystick processing.  However a series of filters
;	are implemented to modify the coordinates and image for various
;	special conditions (exiting, falling, etc.), but in the end, the
;	images are reset based on the information modified by the filters
;
	public	anidork
anidork PROC
	lda	dorkimg
	asl	a		;use to index staani
	asl	a
	asl	a
	tax
	lda	staani+5,x	;save current collision mask
	sta	anitmp
	lda	dorknim 	;set to next animation frame
	sta	dorkimg
;use next image for calculations
	asl	a		;index staani
	asl	a
	asl	a
	tax
;-------------------------------------------------------------------------
;Check for step up or step down
	lda	staani+5,x	;check animation collision mask w/ actual
	and	collide
	and	#$1f
	tay
	beq	nostep		;don't step if no collisions
	lda	staani+4,x	;don't step if char not moving
	beq	nostep
;find ceiling - see if step down works
	lda	staani+5,x
	clc
	ror	a
	and	collide 	;isolate bits
	and	#$1f
	bne	nostep1
	lda	dorky		;ceiling bound - step down
	clc
	adc	#8
	sta	dorky
	ldy	#0		;clear collision bits
	jmp	nostep
nostep1
;check for step up - later, if moving | on lift
	lda	anitmp		;if current image would not collide,
	and	collide
	and	#$1f
	bne	nostep
	lda	staani+5,x	;and next would not if lifted by one
	clc
	rol	a
	and	collide
	and	#$1f
	bne	nostep
	lda	dorky		;step (inc y coordinate)
	sec
	sbc	#8
	sta	dorky
	ldy	#0		;clear side collisions
	jmp	nofall		;don't try falling if stepping up
nostep
;-------------------------------------------------------------------------
;force check to go up if standing in block
	lda	collide 	;force step if standing "in" block
	and	#$40
	lbeq	nostep2
	lda	dorky		;step (inc y coordinate)
	sec
	sbc	#8
	sta	dorky
	cmp	#204
	lbcc	nsxc1
;-------------------------------------------------------------------------
;lift to next room
	lda	#188		;reset Y coord to be at bottom
	sta	dorky

	lda	level		;get and increment current room
	clc
	adc	#2
	and	#$0f		;max is 7
	jmp	dolift
dodnlf
	lda	#4		;reset Y coord to be at top
	sta	dorky
	lda	level		;get and decrement current room
	sec
	sbc	#2
	cmp	#3
	bcs	dolift
	lda	#16		;max is 7

dolift
	sta	lvltmp
	lda	#0
	sta	insrch


	lda	bombtime
	bmi	..notboom
	lda	#0
	sta	bombtime
	jsr	dotbomb
..notboom
	sta	rd_main
	sta	wr_main

	lda	level
	ora	tower16
	and	#$7e
	tax
	lda	walkway-1,x
	and	#$f
	tax
	
	long	prmsec,unbuild

	lda	lvltmp
	sta	level

	move	display,#0
	move	workon,#$20

	lda	level
	ora	tower16 	;set entered bit
	and	#$7e
	tax

	ldy	bulbflg
	beq	ckdrk
	lda	walkway-2,x
	and	#$ef
	sta	walkway-2,x
ckdrk
	lda	walkway-2,x
	and	#$10
	sta	drkflg
	lda	walkway-2,x
	ora	#$20
	sta	walkway-2,x

	lda	walkway-1,x
	and	#$f
	tax
	
	long	prmsec,rebuild

;set/reset lift
	lda	room_p+1	;get number and index (18 bytes/lift)
	ldy	room_p+2
	asl	a
	sta	anitmp1
	asl	a
	asl	a
	asl	a
	adc	anitmp1
	tax
	sta	rd_main
	sta	wr_main
	tya
	sta	lifts+6,x	;move reset pos
	sta	lifts+3,x	;move current pos
	sta	anitmp1
	txa
	tay
	clc
	adc	anitmp1
	tax
	lda	lifts+9,x	;set y pos
	sta	anitmp1
	tya
	tax
	lda	anitmp1
	sta	lifts+1,x
	asl	a
	asl	a
	asl	a
	adc	#4
	sta	dorky

	long	prmsec,clear
	lda	#1
	jsr	build
	long	prmsec,setrob
	long	prmsec,copy_e
	sta	rd_aux
	sta	wr_aux
	lda	dorkx
	sta	entryx
	lda	dorky
	sta	entryy
	lda	#$00
	rts

nsxc1
	jmp	nofall
;-------------------------------------------------------------------------
;Check and process falling
nostep2
	lda	collide 	;check if floor present
	ora	anitmp		;check if last frame didn't allow falling
	and	#$80
	lbne	unfall
	lda	deferfall	;was on lift
	beq	..not_lift_fall
	lda	dorky		;move character down
	clc
	adc	#8
	sta	dorky
	jmp	unfall
..not_lift_fall
	lda	#0		;use standing image for fall
	sta	dorkimg
	tax
	cpy	#0		;if collision, don't adjust X
	bne	nojxa
;actually we should change directions when bouncing off a wall
	inc	dorksta 	;increment state count
	lda	dorksta
	and	#$f
	cmp	#2		;if large enough, adjust X
	lbne	nojxa
	and	#$f0		;reset state count
	ora	#1
	sta	dorksta
	lda	spr_1+2 	;check direction to adjust X
	and	#$80
	bne	jxar
	dec	dorkx
	jmp	nojxa
jxar	inc	dorkx
nojxa
	lda	dorky		;move character down
	clc
	adc	#8
	sta	dorky


****************************
*			   *
*	  START 	   *
* Rich Unruh Modification  *
*			   *

	pha
	lda	lbflg		;for lifts
	bne	ckbottomforlift

	pla
	cmp	#230
	bcs	callscrm
	jmp	nofall

ckbottomforlift
	pla
	cmp	#208
	lbcc	nofall

	lda	lbflg
	lbne	dodnlf
	lda	onlift
	lbne	dodnlf


callscrm
	 sta	  rd_main
	 sta	  wr_main

	long	  prmsec,scream

	 lda	  #$ff
	 sta	  fatalfall

	 sta	  rd_aux
	 sta	  wr_aux

	 lda	  #$00			     ;death return code

	 rts

*			   *
*	   END		   *
* Rich Unruh Modification  *
*			   *
****************************



;reset fall state if floor found
unfall	lda	dorksta 	;reload state with non-falling value
	and	#$f0
	sta	dorksta
;-------------------------------------------------------------------------
;Move with Horizontal Lift
	lda	onlift		;ignore if not on lift
	beq	nohlf
	lda	side		;don't if not in room
	bne	nohlf
	tya			;ignore if colliding
	bne	nohlf
	lda	liftnum 	;lookup lift
	asl	a
	sta	anitmp1
	asl	a
	asl	a
	asl	a
	adc	anitmp1
	stx	anitmp1
	tax
	sta	rd_main
	sta	wr_main
	lda	lifts+2,x	;ignore this for vertical
	bne	nohlf0
	lda	lifts+14,x	;check for moving
	beq	nohlf0
	and	#$fe		;check direction
	beq	hlfrt
	dec	dorkx		;shift animation accordingly
	jmp	nohlf0
hlfrt	inc	dorkx
nohlf0	ldx	anitmp1
nohlf
	sta	rd_aux
	sta	wr_aux

;-------------------------------------------------------------------------
;Normal movement animation

nofall
	lda	onlift
	sta	deferfall
;move based on animation frame amount


****************************
*			   *
*	  START 	   *
* Rich Unruh Modification  *
*			   *

	lda	  dorkimg
	cmp	  #$09
	beq	  dostepsound
	cmp	  #$02
	bne	  nostepsound

dostepsound
	pha
	txa
	pha
	tya
	pha
	sta	  rd_main
	sta	  wr_main
	long	  prmsec,footstep
	sta	  rd_aux
	sta	  wr_aux
	pla
	tay
	pla
	tax
	pla
nostepsound
*			   *
*	   END		   *
* Rich Unruh Modification  *
*			   *
****************************


	lda	spr_1+2 	;check direction
	and	#$80
	lbne	rghtani
	lda	dorkx
	cpy	#0		;don't move if there is a collision
	bne	lcsk
	sec			;dec x through
	sbc	staani+4,x	;animation
	sta	dorkx
	bmi	xitlf		;;;;added
lcsk	sec
	sbc	#2		;adjust for sprite/frame offset
;	bmi	xitlf
	jmp	endanim
;-------------------------------------------------------------------------
;Exit, stage left
xitlf
;exit room - jump to handler based on current location
	lda	#79
	sta	dorkx
	lda	side
	beq	xlf1
	cmp	#$ff
	beq	xlf2
	cmp	#1
	beq	xlf0a		;*** should switch towers
	cmp	#3
	beq	xlf0
	jmp	xlf4
xlf0	lda	#$40
	jmp	xlfx
xlf1

	lda	bombtime
	bmi	..notboom1
	lda	#0
	sta	bombtime
	jsr	dotbomb
..notboom1
	sta	rd_main
	sta	wr_main

	lda	level
	ora	tower16
	and	#$7e
	tax
	lda	walkway-1,x
	and	#$f
	tax
	long	prmsec,unbuild	;copy back positions
	sta	rd_aux
	sta	wr_aux

	lda	#$ff
	sta	side
	jmp	xlf1a
xlf2	lda	#1
	jmp	xlfx


xlf0a
	lda	tower16
	sec
	sbc	#16
	and	#$7f
	sta	tower16
	jsr	gettwr
	lda	#$40
	sta	side
	jmp	xlfx

;-----------------------
;The following code is common for left and right room exits, with different
;entry points used depending on which side
;-----------------------
xlf1a
	lda	level		;recalculate level based on exit height
	and	#$fe
	sta	level
	lda	dorky
	adc	#$20
	rol	a
	rol	a
	and	#1
	eor	#1
	ora	level
	sta	level
	jmp	xlfx1
xlf4	lda	#0
	sta	side
;set up y based on level - top or bottom entry for room
	lda	level
	cmp	#1
	beq	xlfx1
	and	#$1
	beq	xlf5
	lda	#36
	sta	dorky
	jmp	xlfy
xlf5	lda	#188
	sta	dorky
	jmp	xlfy
xlfx	sta	side
;set Y to stand on floors in outer hallways
xlfx1	lda	#$50
	sta	dorky
	sta	rd_main
	sta	wr_main
	long	prmsec,corribui
xlfy	jsr	setroom 	;recalculate and display
	sta	rd_aux
	lda	dorkx
	sta	entryx
	lda	dorky
	sta	entryy
	lda	#$00
	rts			;abort early (animation not valid for switch)

;------------------------------------------------
;Handle right side
rghtani lda	dorkx
	cpy	#0		;don't move if collision
	bne	rcsk
	clc			;inc x through
	adc	staani+4,x	;animation
	sta	dorkx
rcsk	sec
	sbc	#6		;adjust for sprite/frame offset
	cmp	#74
	bmi	endanim
;exit room
	lda	#0		;set coordinates, process based on next side
	sta	dorkx
	lda	side
	beq	xrt1
	cmp	#$ff
	beq	xlf4
	cmp	#1
	beq	xrt3
	cmp	#3
	beq	xrt3a		;*** should switch towers
	lda	#3
	jmp	xlfx
xrt1

	lda	bombtime
	bmi	..notboom2
	lda	#0
	sta	bombtime
	jsr	dotbomb
..notboom2
	sta	rd_main
	sta	wr_main
	
	lda	level
	ora	tower16
	and	#$7e
	tax
	lda	walkway-1,x
	and	#$f
	tax
	long	prmsec,unbuild	;copy back positions
	sta	rd_aux
	sta	wr_aux

	lda	#$40
	sta	side
	jmp	xlf1a
xrt3	lda	#$ff
	jmp	xlfx

xrt3a
	lda	tower16
	clc
	adc	#16
	and	#$7f
	sta	tower16
	jsr	gettwr
	lda	#$ff
	sta	side
	jmp	xlfx

;-------------------------------------------------------------------------
;Finish by setting up appropriate tables

endanim
	sta	spr_1		;save x into light and dark sprites
	sta	spr_1+6
	lda	dorky		;get dark y
	sec
	sbc	staani+2,x	;adjust (bottom of sprite to top)
	sta	spr_1+1 	;set dark
	clc
	adc	staani+3,x	;adjust light y and set
	sta	spr_1+7
	lda	staani,x	;get dark image number
	asl	a
	tay
	lda	tablee,y	;get dark image pointer
	sta	sp_poin
	lda	tablee+1,y
	sta	sp_poin+1
	lda	staani+1,x	;get light image number
	asl	a
	tay
	lda	tablee,y	;set light image pointer
	sta	spr_1+10
	lda	tablee+1,y
	sta	spr_1+11
;copy direction bit
	lda	spr_1+8 	;clear existing bit
	and	#$7f
	sta	spr_1+8
	lda	spr_1+2 	;isolate bit from dark image
	and	#$80
	ora	spr_1+8 	;copy to light image
	sta	spr_1+8
	lda	anitmp
	lsr	a
	and	#$40
	rts
anidork ENDPROC


;get data for tower based on variable TOWER = 16 * index (0-7)
	 public   gettwr
gettwr	proc

	 sta	  rd_main
	 sta	  wr_main

	inc	towrcomp
	ldx	#0
	stx	bulbflg
	txa
	stx	  unlock_flag

	dex
	stx	  pinpos+0
	stx	  pinpos+1
	stx	  pinpos+2

	 cld

	ldx	  #29
..clrpins
	 clc
	 lda	  pins,x
	 adc	  total_pins
	 sta	  total_pins
	 bcc	  ..clrit
	 inc	  total_pins+1
..clrit
	 lda	  #$00
	 sta	  pins,x
	 dex
	 bpl	  ..clrpins

	tax
	lda	#$a0
..loop1tc
	sta	$400,x
	sta	$500,x
	sta	$600,x
	sta	$700,x
	inx
	bne	..loop1tc

	 lda	  tower16
	 cmp	  #$80
	 bcc	  ..normal_tower

;
; fetch last room data here
;
	 lda	  $c083
	 lda	  $c083

	 ldx	  #$00
..lrml1
	 lda	  last_room_data,x
	 sta	  rooms,x
	 sta	  rooms+455,x
	 dex
	 bne	  ..lrml1

	 ldx	  #199
..lrml2
	 lda	  last_room_data+256,x
	 sta	  rooms+256,x
	 sta	  rooms+455+256,x
	 dex
	 cpx	  #$ff
	 bne	  ..lrml2

	 lda	  $c08b
	 lda	  $c08b

	 lda	  #$00
	 sta	  side

	 lda	  #$02
	 sta	  level

	 public   setcrds
setcrds
	 move	  entryx,#38
	 move	  entryy,#180

	 move	  dorkx,entryx
	 move	  dorky,entryy

	 lda	  #$01
	 sta	  drkflg

	 jmp	  ..after_data_fetch


..normal_tower

	lda	#0
	sta	restptr
	lda	#$60
	sta	restptr+1

	ldx	#0
	lda	#low walkway
	sta	punt
	lda	#high walkway
	sta	punt+1
	
	ldx	#128
	ldy	#0
..more_wlk
	lda	(punt),y
	sta	(restptr),y
	iny
	dex
	bne	..more_wlk

	lda	tower16
	jsr	..getnxt
	lda	timer
	jsr	..getnxt
	lda	timer+1
	jsr	..getnxt
	lda	timer+2
	jsr	..getnxt
	lda	timer+3
	jsr	..getnxt
	lda	musics
	jsr	..getnxt
	lda	musics+1
	jsr	..getnxt
	lda	musics+2
	jsr	..getnxt
	lda	musics+3
	jsr	..getnxt
	lda	musics+4
	jsr	..getnxt
	lda	musics+5
	jsr	..getnxt
	lda	towrcomp
	jsr	..getnxt
	lda	total_pins
	jsr	..getnxt
	lda	total_pins+1
	jsr	..getnxt
	lda	tbomb
	jsr	..getnxt
	lda	mine
	jsr	..getnxt
	lda	lightblb
	jsr	..getnxt
	lda	rstlft
	jsr	..getnxt
	lda	mvflr
	jsr	..getnxt
	lda	unplug
	jsr	..getnxt
	lda	sounds
	jsr	..getnxt
	extern	twrmusic
	lda	twrmusic
	jsr	..getnxt
	lda	twrmusic+1
	jsr	..getnxt
	lda	twrmusic+2
	jsr	..getnxt
	lda	twrmusic+3
	jsr	..getnxt
	lda	twrmusic+4
	jsr	..getnxt
	lda	twrmusic+5
	jsr	..getnxt
	lda	twrmusic+6
	jsr	..getnxt
	lda	twrmusic+7
	jsr	..getnxt
	
	lda	initflg
	beq	..nxtxxx
	
;ask if he wants to save... or pass value to get_tower_data
	long	prmsec,save_game

	jmp	..nxtxxx

..getnxt
	sta	(restptr),y
	iny
	rts
	
..nxtxxx

	lda	tower16
	 long	  prmsec,get_tower_data

..after_data_fetch
	long	prmsec,darken
	long	prmsec,copy_e
	long	prmsec,set_dhires

..tryagn1
	jsr	dorand
	and	#$f
	cmp	#10
	bcs	..tryagn1
	sta	corpin+0
..tryagn2
	jsr	dorand
	and	#$f
	cmp	#10
	bcs	..tryagn2
	sta	corpin+1
..tryagn3
	jsr	dorand
	and	#$f
	cmp	#10
	bcs	..tryagn3
	sta	corpin+2

;***********

	long	prmsec,clrhid

	lda	corpin
	clc
	adc	#1
	jsr	doent1
	lda	anitmp1
	jsr	doent1

	lda	corpin+1
	clc
	adc	#11
	jsr	doent1
	lda	anitmp1
	jsr	doent1

	lda	corpin+2
	clc
	adc	#21
	jsr	doent1
	lda	anitmp1
	jsr	doent1

	lda	#15
	sta	anitmp1
..contpinfill
	jsr	dorand
	tax
	jsr	dorand
	and	#31
	jsr	doent
	dec	anitmp1
	bne	..contpinfill

..contpinfill1
	jsr	dorand
	tax
	jsr	dorand
	and	#$7
	cmp	#6
	bcs	..contpinfill1
	clc
	adc	#31
	jsr	doent
	beq	..contpinfill1

	 sta	  rd_aux
	 sta	  wr_aux

	ldx	#191
	lda	#0
..clrbmb
	sta	bombmem,x
	dex
	bne	..clrbmb
	sta	bombmem,x

	lda	tower16
	cmp	#$80
	bcc	..normal_exit

	jsr	setroom

..normal_exit
	rts

doent1
	sta	anitmp1
	jsr	dorand
	tax
	lda	anitmp1
doent
	ldy	tower16
	long	prmsec,enthid
	rts

dorand	long	prmsec,random
	rts

gettwr	endproc


	END
