$chip(6502)
$title(Impossible Mission II)
$subtitle(Build the Room Table)
$paginate
$indent=8

**********************************************
*					     *
*					     *
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc
	%include matrix.inc

	EXTERN	rd_main, wr_main, rd_aux, wr_aux, scanhi, scanlo
	
	EXTERN	x_pos, y_pos, length
	EXTERN	n_walls, walls, n_floors, floors
	EXTERN	n_sfloors, sfloors, n_niches, niches
	EXTERN	n_lifts, lifts, MAXPOS, MOVING

	extern	fwtab

ltype	equ	2
c_pos	equ	8
n_pos	equ	7
v_pos	equ	9

	PUBLIC	build1

	seg	page0

	single	x1
	single	x2
	single	y1
	single	y2
	single	objtmp
	single	count
	double	ptr2
	single	cnt2

	single	xpos
	single	ypos
	single	offset
	single	dist

	SEG	temps

	double	point

	single	spxofs
	single	spyofs
	single	len
	single	hght
	single	depth
	single	tempy
	single	loop
	single	fndflg

	seg	graph

build1	PROC
	lda	#0
	tax

..loop1 sta	$400,x
	sta	$500,x
	sta	$600,x
	sta	$700,x
	inx
	bne	..loop1

	ldx	#39

..looph sta	$800,x
	dex
	bpl	..looph

**********************************************
*		Walls			     *
**********************************************

	move	count,n_walls
	ldx	#0

..loop3 lda	walls+length,x
	sta	len
	lda	walls+y_pos,x
	asl	a
	asl	a
	asl	a
	sta	ypos
	lda	walls+x_pos,x
	sta	xpos
	sta	rd_aux

..loop2 ldy	ypos
	cpy	#200
	bcs	..nxwal
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1

	ldy	xpos
	lda	#$81
	sta	(point),y
	add	ypos,8
	dec	len
	bne	..loop2

..nxwal sta	rd_main
	inx
	inx
	inx
	dec	count
	bne	..loop3

**********************************************
*		Floors			     *
**********************************************

	move	count,n_floors
	beq	..efl
	ldx	#0

..loop4 lda	floors+length,x
	sta	len
	lda	floors+y_pos,x
	asl	a
	asl	a
	asl	a
	tay
	cpy	#200
	bcs	..nxflr

	sta	rd_aux
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	sta	rd_main

	ldy	floors+x_pos,x
	lda	#$82

..loop5 sta	(point),y
	iny
	dec	len
	bne	..loop5

..nxflr inx
	inx
	inx
	dec	count
	bne	..loop4

..efl

**********************************************
*	Holes				     *
**********************************************

	lda	#8
	sta	count
	ldx	#0

	extern	holes

..loop4z lda	#3
	sta	len
	sta	rd_aux
	lda	holes,x
	cmp	#2
	bne	..nxhol
	lda	holes+2,x
	clc
	adc	#1	;floor below bomb Y
	asl	a
	asl	a
	asl	a
	tay

	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	
	ldy	holes+1,x	;get x
	dey			;patch
	sta	rd_main
	lda	#0

..loop5z sta	(point),y
	iny
	dec	len
	bne	..loop5z
	
..nxhol sta	rd_main
	inx
	inx
	inx
	dec	count
	bne	..loop4z

**********************************************
*		Special Floors		     *
**********************************************

	move	count,n_sfloors
	beq	..esf
	ldx	#0

..loop6 lda	sfloors+length,x
	sta	len
	lda	sfloors+y_pos,x
	asl	a
	asl	a
	asl	a
	tay
	cpy	#200
	bcs	..nxsfl

	sta	rd_aux
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	sta	rd_main

	ldy	sfloors+x_pos,x
	lda	#$83

..loop7 sta	(point),y
	iny
	dec	len
	bne	..loop7

..nxsfl inx
	inx
	inx
	inx
	dec	count
	bne	..loop6

..esf

**********************************************
*		Matrix Build		     *
**********************************************

	move	ypos,#0

..loop8 ldy	ypos
	sta	rd_aux
	lda	scanlo,y
	sta	point
	lda	scanlo+8,y
	sta	ptr2
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	lda	scanhi+8,y
	clc
	adc	#$04
	sta	ptr2+1
	sta	rd_main

	ldy	#39

..loop9 move	count,#0

	cpy	#0
	beq	..nlft1

	dey
	lda	(ptr2),y
	ror	a
	ror	a
	ror	a
	and	#$c0
	sta	count
	iny

..nlft1 lda	(ptr2),y
	asl	a
	asl	a
	asl	a
	asl	a
	ora	count
	sta	count

..ndwn	cpy	#0
	beq	..nlft2

	dey
	lda	(point),y
	asl	a
	asl	a
	ora	count
	sta	count
	iny

..nlft2 lda	(point),y
	and	#$03
	ora	count
	tax
	lda	fwtab,x
	sta	(point),y

	dey
	bpl	..loop9

	cmp	#TFL
	bne	..skp01

	iny
	lda	#TOP
	sta	(point),y

..skp01 add	ypos,8
	cmp	#192
	bcc	..loop8

**********************************************
*		Niches			     *
**********************************************

	move	count,n_niches
	lbeq	..enic
	ldx	#0

..lp10	lda	niches+x_pos,x
	clc
	adc	#1
	sta	xpos
	lda	niches+4,x
	sta	depth
	lda	niches+length,x
	cmp	depth
	bcs	..ok1

	sta	depth

..ok1	sta	len
	lda	niches+3,x
	sta	hght
	sec
	sbc	#1
	cmp	depth
	bcc	..do
	bne	..ok2

..do	sta	depth

..ok2	lda	niches+y_pos,x
	clc
	adc	hght
	sec
	sbc	#2
	asl	a
	asl	a
	asl	a
	sta	ypos

..lp11	move	tempy,ypos
	move	loop,hght

..lp12	sta	rd_aux		; side
	ldy	tempy
	cpy	#192
	bcs	..sdon
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	sta	rd_main
	ldy	xpos
	lda	(point),y
	and	#$c0
	ora	#(SID and $3f)	; fwtab+68
	sta	(point),y
	sub	tempy,8
	dec	loop
	bne	..lp12

	lda	(point),y
	and	#$c0
	ora	#(F_S and $3f)	; top (fwtab+70)
	sta	(point),y

..sdon	sta	rd_aux		; corner & floor
	ldy	ypos
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	sta	rd_main

	ldy	xpos
	lda	#S_T		;corner
	sta	(point),y
	iny

	move	loop,len
	dec	loop
	beq	..nflo
	lda	#TOP		;floor

..lp13	sta	(point),y
	iny
	dec	loop
	bne	..lp13

..nflo	sub	ypos,8
	inc	xpos
	dec	len
	dec	hght
	dec	depth
	lbne	..lp11

	lda	len
	beq	..ntop
	bmi	..ntop

	clc
	adc	xpos
	sec
	sbc	#1
	sta	xpos

..lp14	sta	rd_aux		; right edge
	ldy	ypos
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	sta	rd_main

	ldy	xpos
	lda	(point),y
	and	#$c0
	ora	#(NEN and $3f)
	sta	(point),y

	sub	ypos,8
	bcc	..ntop
	dec	hght
	bne	..lp14

	lda	(point),y
	and	#$c0
	ora	#(NET and $3f)
	sta	(point),y
	dey
	dec	len
	beq	..ntop

..lp15	lda	(point),y
	and	#$c0
	ora	#(IFL and $3f)	;top
	sta	(point),y
	dey
	dec	len
	bne	..lp15

..ntop	inx
	inx
	inx
	inx
	inx
	dec	count
	lbne	..lp10

..enic

**************************************
* Lifts 			     *
**************************************

	move	count,n_lifts
	lbeq	..nolft

	ldx	#0

;--------for each lift------------

..lftlp
	ldy	lifts+n_pos,x		;x indexes the lifts structure
	dey			;y has the number of positions
	sty	len	     ;translate y to index to last position
	txa
	clc
	adc	len
	tay

	lda	lifts+c_pos,x
	sta	xpos
	lda	lifts+v_pos,x
	sta	ypos
	sec
	lda	lifts+v_pos,y	;calculate number of characters
	sbc	lifts+v_pos,x
	sta	len

	lda	lifts+ltype,x	  ;vert or horiz?
	beq	..hzlift

;---------draw vertical lift lines ----------

	inc	xpos
	inc	xpos
	dec	ypos
	inc	len
;draw lines in - increasing Y for len chars
	lda	ypos
	asl	a
	asl	a
	asl	a
	sta	ypos

	sta	rd_aux

..vdrw
	ldy	ypos
	cpy	#192
	bcs	..endlf

	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	ldy	xpos
	lda	#VLF
	sta	(point),y

..endlf
	add	ypos,8
	dec	len
	bne	..vdrw
	sta	rd_main
	jmp	..nxlft

;---------draw horizontal lift lines ----------

..hzlift
	lda	xpos
	ldy	ypos
	iny		;increment x position
	iny
	sty	xpos
	sec
	sbc	#1
	asl	a	;translate to pointer
	asl	a
	asl	a
	tay
	sta	rd_aux
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1
	sta	rd_main
;draw lines in - increasing X for len chars
	ldy	xpos
	lda	#HLF

..dwlp	sta	(point),y
	iny
	dec	len
	bne	..dwlp

;--------proceed to next lift----------

..nxlft
	dec	count
	beq	..nolft

	txa
	clc
	adc	#18
	tax
	jmp	..lftlp

..nolft
	rts
	
build1	endproc
	end
