$chip(6502)
$title(Impossible Mission II)
$subtitle(Build the Room Table)
$paginate
$indent=8

**********************************************
*					     *
*	Set-up for elevator move	     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	n_lifts, lifts, y_pos, x_pos, putlift
	EXTERN	MAXPOS, MOVING, erlift, erbuff
	EXTERN	wr_aux, wr_main

	PUBLIC	movlift

	SEG	page0

	single	eptr
	single	offset
	single	count
	single	cnt2
	single	xpos
	single	ypos
	single	dist

	SEG	maincode

movlift PROC

	move	eptr,#$28
	move	count,n_lifts
	lbeq	..done
	move	offset,#0

..loopl ldx	offset
	lda	lifts+MOVING,x
	lbeq	..nxlft

	lda	lifts+4,x
	sta	cnt2
	lda	lifts+y_pos,x
	sec
	sbc	#1
	sta	ypos
	lda	lifts+x_pos,x
	sta	xpos
	lda	lifts+5,x
	sta	dist
	lda	lifts+2,x
	lbeq	..horiz

	txa
	clc
	adc	lifts+3,x
	tay
	lda	lifts+1,x
	cmp	lifts+9,y
	lbeq	..stop

	lda	lifts+1,x
	clc
	adc	lifts+MOVING,x
	sta	lifts+1,x

..vert	ldx	offset
	lda	lifts+MOVING,x
	bmi	..up

..down	lda	#3
	ldy	ypos
	ldx	xpos
	jsr	erlift

	ldx	#24
	jsr	..lfsub

	ldy	ypos
	ldx	xpos
	iny
	jsr	putlift
	jmp	..vend

..up	lda	#1
	ldy	ypos
	ldx	xpos
	jsr	erlift

	dec	ypos
	ldx	#24
	jsr	..lfsub
	inc	ypos

	ldy	ypos
	ldx	xpos
	dey
	jsr	putlift
..vend	add	eptr,4
	lda	ypos
	clc
	adc	dist
	cmp	#24
	lbcs	..nxlft
	sta	ypos
	dec	cnt2
	lbne	..vert
	jmp	..nxlft

..horiz txa
	clc
	adc	lifts+3,x
	tay
	lda	lifts+0,x
	cmp	lifts+9,y
	lbeq	..stop

	lda	lifts+MOVING,x
	bmi	..left

..right inc	lifts+0,x
	lda	#0
	ldy	ypos
	ldx	xpos
	jsr	erlift

	ldx	#16
	jsr	..lfsub

	ldy	ypos
	ldx	xpos
	inx
	jsr	putlift
	add	eptr,4
	jmp	..nxlft

..left	dec	lifts+0,x
	lda	#2
	ldy	ypos
	ldx	xpos
	jsr	erlift

	dec	xpos
	ldx	#16
	jsr	..lfsub
	inc	xpos
	
	ldy	ypos
	ldx	xpos
	dex
	jsr	putlift
	add	eptr,4

..nxlft ldx	offset
	add	offset,13+MAXPOS
	dec	count
	lbne	..loopl

..done	rts

..stop	lda	#0
	sta	lifts+MOVING,x
	jmp	..nxlft

..lfsub
	sta	wr_aux
	lda	xpos
	and	#$fe
	ldy	eptr
	sta	erbuff+$00,y
	sta	erbuff+$40,y
	lda	ypos
	asl	a
	asl	a
	asl	a
	sta	erbuff+$01,y
	sta	erbuff+$41,y
	lda	#$e6
	sta	erbuff+$03,y
	sta	erbuff+$43,y
	txa
	sta	erbuff+$02,y
	sta	erbuff+$42,y
	sta	wr_main
	rts

movlift ENDPROC

	END
