$chip(6502)
$title(Impossible Mission 2)
$paginate
$indent=8
**********************************************
*					     *
*	      Main code 		     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	setroom, erbuff
	EXTERN	wr_main, wr_aux, rd_main, rd_aux
	EXTERN	draw, erasp, prmsec, stick
	EXTERN	spr_1
	EXTERN	page1, page2
	EXTERN	workon, stkval(page0)
	EXTERN	joycal, sp_poin
	EXTERN	tablee,staani,disbuf,disbuf1	;animation constants
	EXTERN	scanlo, scanhi	      ;used to find collisions
	EXTERN	movlift, dot(page0)
	extern	pinpos,stamp_out_l_door,stamp_out_r_door
	EXTERN	lifts,N_LIFTS
	EXTERN	timer, prtime, corpin, tcount, tapcnt, musics
	extern	dorobot,bombtime,havebomb,onlift
	extern	dobmb1
	extern	reslfts,unbuild,played
	extern	protoww,walkway

	extern	fizzle,total_pins
	extern	 score_screen,set_dhires,clear,towrcomp
	extern	colldet,joyproc,anidork,disolv,dodis,boom
	extern	pins,insrch,gettwr,entryx,entryy
	extern	holes,robmb,roboom,build,tower_door_flag

	 extern   unlock_flag,stone,stamp,copy_b,soundflag
	extern	random
	extern	init
	extern	twrmusic,goodterm
	extern	srchflg,donesch

	PUBLIC	display, start, level, side, tower16
	PUBLIC	clock, updtim, stunflg, bulbflg
	PUBLIC	dorkx,dorky,dorkimg,dorknim,dorksta
	public	  door_opened_flag,fatalfall,last_room_flag
	public	deadflg,initflg

	 seg	  temps
temp1	 ds	  1
temp2	 ds	  1
tdbl1	 ds	  2

	SEG	PAGE0

	 single   door_opened_flag
	 single  last_room_flag

	single	initflg		;set after first tower loaded (stops SAVE?)
	single	display 	;which screen to display
	single	frmcnt

	single	stunflg 	;set when robots stunned
	single	dorkimg 	;current animation image number
	single	dorknim 	;next frame animation image number
	single	dorkx		;X coordinate of character (0-79)
	single	dorky		;Y coordinate of character
	single	dorksta 	;state (0 -> not falling)

	single	level
	single	side
	single	tower16
	single	clock

	single	deadflg
	single	bulbflg

	single fizztime
	single fatalfall

	single	used_rooms
	single	avail_rooms
	single	room_bit
	double	restptr
	double	restptr1
	
	SEG	setup

;**************************************************************************
;*	GENERAL INITIALIZATION
;**************************************************************************

start	PROC

	sta	rd_main
	sta	wr_main
	lda	$c010		;clear keyboard strobe
	cld

	lda	#0
	sta	initflg
	sta	dorkimg
	sta	dorksta
	sta	deadflg
	sta	played
	sta	tapcnt
	sta	tcount
	sta	tcount+1
	sta	tower_door_flag
	sta	last_room_flag
	sta	total_pins
	sta	total_pins+1
	sta	soundflag
	sta	fatalfall
	sta	havebomb
	sta	stunflg
	sta	srchflg
	sta	donesch
	sta	musics+0
	sta	musics+1
	sta	musics+2
	sta	musics+3
	sta	musics+4
	sta	musics+5
	sta	corpin+0
	sta	corpin+1
	sta	corpin+2
	sta	timer
	sta	timer+1
	sta	timer+2
	move	timer+3,#$08

	move	dorky,#$48	;somewhere
	move	dorkx,#40
	lda	#$ff
	sta	pinpos+0
	sta	pinpos+1
	sta	pinpos+2
	sta	unlock_flag
	sta	bombtime
	sta	towrcomp

	lda	#0		;clear usable object counts (pins, bombs)
	ldx	#37
..clpn	sta	pins,x
	dex
	bpl	..clpn

	move	  display,#$00
	move	  workon,#$20
	long	  prmsec,clear
	move	  workon,#$40

..waitletgo
	long	prmsec,random

	jsr	stick		;get input
	and	#$c0
	bne	..waitletgo
	cpx	#0
	bne	..waitletgo

	long	prmsec,joycal

;set up walkways - scramble copy protoww to walkway
;always copy room 0, if copying room 1, include room 2 and put both in the
;top two positions (room 2 being higher).  Set bit 0x10 of first byte to
;make room dark

	extern	walkway,timer,musics,towrcomp,total_pins,tbomb,mine
	extern	lightblb,rstlft,mvflr,unplug,sounds
;
	extern	restore_game
	long	prmsec,restore_game
;
	cmp	#0
	lbne	..dogen

	lda	#0
	sta	restptr
	lda	#$60
	sta	restptr+1


	ldx	#0
	lda	#low walkway
	sta	restptr1
	lda	#high walkway
	sta	restptr1+1
	
	ldx	#128
	ldy	#0
..more_wlk
	lda	(restptr),y
	sta	(restptr1),y
	iny
	dex
	bne	..more_wlk

	jsr	..getnxt
	sta	tower16
	jsr	..getnxt
	sta	timer
	jsr	..getnxt
	sta	timer+1
	jsr	..getnxt
	sta	timer+2
	jsr	..getnxt
	sta	timer+3
	jsr	..getnxt
	sta	musics
	jsr	..getnxt
	sta	musics+1
	jsr	..getnxt
	sta	musics+2
	jsr	..getnxt
	sta	musics+3
	jsr	..getnxt
	sta	musics+4
	jsr	..getnxt
	sta	musics+5
	jsr	..getnxt
	sta	towrcomp
	jsr	..getnxt
	sta	total_pins
	jsr	..getnxt
	sta	total_pins+1
	jsr	..getnxt
	sta	tbomb
	jsr	..getnxt
	sta	mine
	jsr	..getnxt
	sta	lightblb
	jsr	..getnxt
	sta	rstlft
	jsr	..getnxt
	sta	mvflr
	jsr	..getnxt
	sta	unplug
	jsr	..getnxt
	sta	sounds
	jsr	..getnxt
	sta	twrmusic
	jsr	..getnxt
	sta	twrmusic+1
	jsr	..getnxt
	sta	twrmusic+2
	jsr	..getnxt
	sta	twrmusic+3
	jsr	..getnxt
	sta	twrmusic+4
	jsr	..getnxt
	sta	twrmusic+5
	jsr	..getnxt
	sta	twrmusic+6
	jsr	..getnxt
	sta	twrmusic+7
	jmp	..start_game

..getnxt
	lda	(restptr),y
	iny
	rts


..dogen

	ldx	#127		;clear it
	lda	#0
..suww
	sta	walkway,x
	dex
	bpl	..suww


	lda	#0
	sta	tower16

..top_twr_fill	
	lda	#0
	sta	used_rooms
	sta	avail_rooms
;randomly place the top two towers
	long	prmsec,random
	and	#$1
	bne	..no_top_two
	lda	#$30
	ora	used_rooms
	sta	used_rooms
	ldx	tower16
	inx
	inx
	lda	protoww,x
	sta	walkway+6,x
	lda	protoww+1,x
	sta	walkway+7,x
	lda	protoww+2,x
	sta	walkway+8,x
	lda	protoww+3,x
	sta	walkway+9,x
..no_top_two

	long	prmsec,random
	and	#$6
	tay
	ora	tower16
	tax
	lda	#1
..ck_nxt_bit
	cpy	#0
	beq	..fnd_first_bit
	asl	a	
	dey
	dey
	jmp	..ck_nxt_bit
..fnd_first_bit
	ora	used_rooms
	sta	used_rooms
	lda	tower16
	tay
	lda	protoww,y
	sta	walkway,x
	lda	protoww+1,y
	sta	walkway+1,x

;Now add the other rooms in the tower
	lda	#$7
	sta	avail_rooms

..try_again_1
	long	prmsec,random
	and	#7
	tay
	beq	..try_again_1
	asl	a
	ora	tower16
	tax

	iny
	lda	#1
	sta	room_bit
	jmp	..ckinlp
..ck_nxt_bit1
	asl	room_bit
..ckinlp
	dey
	bne	..ck_nxt_bit1
	lda	room_bit
	and	avail_rooms
	bne	..try_again_1
	lda	room_bit
	ora	avail_rooms
	sta	avail_rooms

	lda	#1
	sta	room_bit
	lda	used_rooms
	ldy	#$ff
..ck_nxt_used1
	asl	room_bit
	iny
	ror	a
	bcs	..ck_nxt_used1
	lsr	room_bit
	lda	used_rooms
	ora	room_bit
	sta	used_rooms
	tya
	asl	a
	ora	tower16
	tay
	lda	protoww,x
	sta	walkway,y
	lda	protoww+1,x
	sta	walkway+1,y

	lda	used_rooms
	and	#$f
	cmp	#$f
	bne	..try_again_1
	lda	used_rooms
	cmp	#$3f
	beq	..tower_filled
	long	prmsec,random
	and	#$1
	bne	..try_again_1

..tower_filled
;Do next tower
	lda	tower16
	clc
	adc	#$10
	sta	tower16
	lbpl	..top_twr_fill

;insert (max) 2 dark rooms
	long	prmsec,random
	and	#$7e
	tax
	lda	walkway,x
	ora	#$10
	sta	walkway,x

	long	prmsec,random
	and	#$7e
	tax
	lda	walkway,x
	ora	#$10
	sta	walkway,x


;randomize tower number
	long	prmsec,random
	and	#$70
	sta	tower16

	ldx	#7
	lda	#0
	sta	avail_rooms
..get_mus
	long	prmsec,random
	and	#7
	cmp	#6
	bcs	..get_mus

	sta	used_rooms
	tay
	iny
	lda	avail_rooms
	cmp	#$3f
	beq	..nochkmus
	lda	#1
	sta	room_bit
	jmp	..ckinlpx
..ck_nxt_bitx
	asl	room_bit
..ckinlpx
	dey
	bne	..ck_nxt_bitx
	lda	room_bit
	and	avail_rooms
	bne	..get_mus
	lda	room_bit
	ora	avail_rooms
	sta	avail_rooms
..nochkmus
	lda	used_rooms
	clc
	adc	#1
	sta	twrmusic,x
	dex
	bpl	..get_mus

..start_game
	long	prmsec,random
	and	#3
	cmp	#3
	beq	..start_game
	sta	goodterm

;;;	long	prmsec,set_dhires
	sta	wr_aux

	lda	#5		;grey
	sta	spr_1+2
	lda	#15		;white
	sta	spr_1+8

	ldx	#$7f		;this does some kind of initalization
	lda	#0		;which lifts use
..lpze	sta	erbuff,x
	dex
	bpl	..lpze
	sta	wr_main

	lda	#1		;set up for bottom room in tower
	sta	level
	lda	#$ff
	sta	side

	jsr	gettwr

	lda	#$ff
	sta	initflg

	lda	#0
	sta	dot
	lda	#$20
	sta	dot+1

	jsr	setroom

	move	  deadflg,#$00

	jmp	loop

	ENDPROC start

;**************************************************************************
;*	MAIN LOOP
;**************************************************************************

	SEG	maincode
	public	loop
loop	PROC

;REMOVED VBL DELAY

	lda	side
	bne	nomvlf

	lda	insrch
	bne	nomvlf

	lda	level
	cmp	#1
	beq	nomvlf

	inc	frmcnt
	lda	frmcnt
	and	#1
	beq	nomvlf		;only move lift every other frame
	jsr	movlift
nomvlf
	lda	  unlock_flag
	beq	  ..doors_locked

	lda	  side
	beq	  ..not_between_towers

	cmp	  #$03
	bcc	  ..left_of_tower

	bne	  ..not_between_towers

..right_of_tower
	 lda	  door_opened_flag
	 bne	  ..its_open

	 jsr	  raze_leftwal
	 lda	  #$ff
	 sta	  door_opened_flag
	 bne	  ..its_open

..left_of_tower
	 lda	  door_opened_flag
	 bne	  ..its_open

	 jsr	  raze_rghtwal
	 lda	  #$ff
	 sta	  door_opened_flag


..its_open
..not_between_towers
..doors_locked

	jsr	stick		;get input

	lda	  side
	bne	  ..no_suicide_key
	lda	  level
	cmp	  #02
	bcc	  ..no_suicide_key

	txa
	and	  #%01111111
	cmp	  #$1b
	bne	  ..not_paused
	lda	  #$02
	ora	  deadflg
	sta	  deadflg

..no_suicide_key
	txa
	and	  #%01111111
	cmp	#$12
	lbeq	init
	cmp	#'P'
	bne	..not_paused1
..paused
	jsr	stick		;get input
	txa
	beq	..paused

	cmp	#$1a
	bne	..notcheat
	lda	level
	cmp	#13
	bne	..notcheat
	lda	side
	cmp	#3
	bne	..notcheat
	lda	stkval
	and	#$c0
	cmp	#$c0
	bne	..notcheat
	
	lda	#9		;set usable object counts (pins, bombs)
	ldx	#37
..clpncht	sta	pins,x
	dex
	bpl	..clpncht
	ldy	#6
	ldx	#0
..nxmus	tya
	sta	musics,x
	inx
	dey
	bne	..nxmus
	move	timer+3,#$08

..notcheat
	jmp	..no_suicide_key
..not_paused

;test for mode debug keys
;	cmp	 #'C'
;	bne	..noclrbmbs
;	
;	sta	wr_aux
;
;	ldy	#71
;	lda	#0
;..clblp	sta	holes,y
;	dey
;	bpl	..clblp
;
;	sta	wr_main
;
;	jmp	..not_paused1
;..noclrbmbs
;	cmp	#'H'
;	bne	..not_paused1
;	lda	#1
;	sta	havebomb
;
..not_paused1

	sta	rd_aux
	sta	wr_aux
	jsr	colldet 	;check main collision detection
	tay
	ora	deadflg
	sta	deadflg
	tya
	cmp	#$6
	bne	..nobmm
;he stepped on one

	ldy	#0
..hllp	lda	holes,y
	cmp	#1
	beq	..fndhl1
	cmp	#4
	beq	..fndhl1
..hllp1	iny
	iny
	iny
	cpy	#24
	bne	..hllp
	jmp	..nobmm		;???????? didn't find bomb

	sta	rd_main
	sta	wr_main
	long	prmsec,boom
	sta	rd_aux
	sta	wr_aux

..fndhl1
	lda	dorkx
	lsr	a

	cmp	holes+1,y
	bne	..hllp1
	lda	dorky
	sec
	sbc	#4		;offset for actual floor
	lsr	a
	lsr	a
	lsr	a
	cmp	holes+2,y
	bne	..hllp1
	lda	holes,y
	clc
	adc	#1
	sta	holes,y
	
..nobmm
	
	jsr	joyproc 	;process joystick inputs
	jsr	anidork 	;animate player
	ora	deadflg 	;undo dead for parts of animation
	sta	deadflg

	sta	rd_main
	sta	wr_main
	lda	side
	lbne	norob
	lda	level
	cmp	#1
	lbeq	norob
	lda	insrch
	sta	srchflg
	lda	stunflg
	ldx	dorkx
	ldy	dorky
	long	prmsec,dorobot
;grabbed by robot logic
	cmp	#0
	beq	..nogrb
	tay
	and	#$2
	ora	deadflg
	sta	deadflg
	tya
	and	#$2
	beq	..grbdo
	jmp	..nogrb
..grbdo
	lda	onlift
	lbne	..nogrb

	lda	deadflg
	and	#$40
	bne	..nogrb
	sta	rd_aux
	sta	wr_aux
	lda	spr_1+2
	and	#$f
	sta	spr_1+2
	lda	spr_1+8
	and	#$f
	sta	spr_1+8
	tya
	and	#$80
	ora	spr_1+2
	sta	spr_1+2
	tya
	and	#$80
	ora	spr_1+8
	sta	spr_1+8

	tya
	and	#$4
	beq	..nopsh
	tya
	and	#$80
	beq	..lft
	inc	dorkx
	tya
	and	#8
	beq	..nopsh
	inc	dorkx
	jmp	..nopsh
..lft
	dec	dorkx
	tya
	and	#8
	beq	..nopsh
	dec	dorkx
..nopsh
	sta	rd_main
	sta	wr_main
	lda	dorksta
	ora	#$80
	jmp	..grb
..nogrb lda	dorksta
	and	#$0f
..grb	sta	dorksta
*tz
	sta	wr_aux
	sta	rd_aux
	lda	robmb
	beq	..noplcb
	lda	#4
	ldx	robmb+1
	ldy	robmb+2
	sta	rd_main
	sta	wr_main
	long	prmsec,dobmb1

..noplcb
	sta	wr_aux
	sta	rd_aux
	lda	roboom
	beq	..noboom

	sta	rd_main
	sta	wr_main
	long	prmsec,boom
	sta	rd_aux
	sta	wr_aux

	ldy	#0
..nfnhl	lda	holes,y
	and	#$80
	bne	..fndhl
	iny
	iny
	iny
	jmp	..nfnhl
..fndhl
	lda	holes,y
	and	#$7f
	sta	holes,y
	sta	rd_main
	sta	wr_main
	long	prmsec,clear
	jsr	build
	jsr	copy_b
..noboom
norob
	sta	rd_main
	sta	wr_main
*tz
***-----------------------------------------------------------------------
***-----------------------------------------------------------------------
	 lda	  tower_door_flag
	 bpl	  ..ck_for_other_death

	 lda	  #$00
	 sta	  tower_door_flag

;
; check the "all musics have played" flag here
;
	lda	played
	and	#$3f
	cmp	#$3f
	bne	..doesnt_have_all_his_music

	 lda	  #$ff
	 sta	  last_room_flag
	 lda	  #$80
	 sta	  tower16

	 jsr	  gettwr
	 move	  deadflg,#$00
	 jmp	  loop


..doesnt_have_all_his_music
	 lda	  #$02
	 sta	  deadflg
	 jmp	  ..do_us_a_favor


..ck_for_other_death
	 lda	  #$02
	 and	  deadflg
	 beq	  ..im_not_dead_yet  ;'ere...he says he's not dead !
	 lda	  #$40
	 and	  deadflg
	 bne	  ..im_not_dead_yet  ;'ere...he says he's not dead !

..do_us_a_favor
	long	prmsec,disolv	;this freezes the image for dissolution

..im_not_dead_yet	   ;I don't want to dissolve...

***-----------------------------------------------------------------------

	ldx	display 	;change page to display
	sta	page1,x
	txa
	eor	#1
	sta	display
	lda	workon
	eor	#$60
	sta	workon

	long	prmsec,erasp	;copy erase screen
	long	prmsec,draw	;draw sprites

	jsr	updtim

	 lda	  fatalfall
	 lbmi	  ..death_penalty

	lda	deadflg
	and	#2
	lbeq	..nofiz
	lda	deadflg
	and	#$40
	lbne	..nofiz

..dofizzle
	 lda	  #$20
	 sta	  fizztime

..fizzlp
	long	  prmsec,fizzle

	ldx	display 	;change page to display
	sta	page1,x
	txa
	eor	#1
	sta	display
	lda	workon
	eor	#$60
	sta	workon

	long	prmsec,erasp	;copy erase screen
	long	prmsec,draw	;draw sprites

	long	prmsec,dodis		;dissolve (jsr 64+ times to complete)

	 dec	  fizztime
	 bpl	  ..fizzlp


	sta	rd_aux
	sta	wr_aux
	lda	spr_1+2
	and	#$f0
	ora	#$5
	sta	spr_1+2
	lda	spr_1+8
	ora	#$f
	sta	spr_1+8
	sta	rd_main
	sta	wr_main

..death_penalty
	 lda	  timer+3
	 bne	  ..deduct_time
	 lda	  timer+2
	 cmp	  #$06
	 bcs	  ..deduct_time

	 lda	  #$00
	 sta	  timer+1
	 sta	  timer+2
	 beq	  ..after_death

..deduct_time
	 sed

	 lda	  timer+2
	 sec
	 sbc	  #$06
	 cmp	  #$59
	 bcc	  ..store_minutes_now

	 pha

	 lda	  timer+3
	 sec
	 sbc	  #$01
	 sta	  timer+3

	 pla
	 sta	  temp2

	 lda	  #$00
	 sec
	 sbc	  temp2
	 sta	  temp2

	 lda	  #$60
	 sec
	 sbc	  temp2


..store_minutes_now
	 sta	  timer+2

	 cld


..after_death
	 lda	  #$00
	 sta	  fatalfall

	lda	bombtime
	bmi	..notboom
	lda	#0
	sta	bombtime
	extern	dotbomb
	jsr	dotbomb
..notboom
	sta	rd_main
	sta	wr_main
	
	long	prmsec,reslfts
	lda	level
	ora	tower16
	and	#$7e
	tax
	lda	walkway-1,x
	and	#$f
	tax
	long	prmsec,unbuild

	 jsr	  setroom
;*tz
	lda	#0
	sta	dorksta
	sta	dorkimg
	sta	dorknim
	 move	  dorky,entryy
	lda	entryx
	sta	dorkx
	cmp	#40
	bcc	..faceright

	sta	rd_aux
	sta	wr_aux
	lda	spr_1+2
	and	#$f
	sta	spr_1+2
	lda	spr_1+8
	and	#$f
	sta	spr_1+8
	sta	rd_main
	sta	wr_main
	jmp	..donefacing
..faceright
	sta	rd_aux
	sta	wr_aux
	lda	spr_1+2
	and	#$f
	ora	#$80
	sta	spr_1+2
	lda	spr_1+8
	and	#$f
	ora	#$80
	sta	spr_1+8
	sta	rd_main
	sta	wr_main

..donefacing
;*tz
	
	 move	  deadflg,#$40	;no immed death
	 jmp	loop

..nofiz

	 move	  deadflg,#$00

	jmp	loop

loop	ENDPROC

updtim	PROC

	dec	timer
	bpl	..notim

	move	timer,#30

	lda	stunflg
	beq	..notstnd
	dec	stunflg
..notstnd
	lda	bombtime
	bmi	..nobmbt
	dec	bombtime
..nobmbt

	sed
	lda	timer+1
	beq	..cary1

	sec
	sbc	#1
	sta	timer+1
	jmp	..dnet

..cary1 move	timer+1,#$59

	lda	timer+2
	beq	..cary2

	sec
	sbc	#1
	sta	timer+2
	jmp	..dnet

..cary2 move	timer+2,#$59

	lda	timer+3
	sec
	sbc	#1
	cmp	#$99
	bne	store_hours

;
; display elvin screen here
;

	move	  timer+1,#$00
	move	  timer+2,#$00

	long	  prmsec,score_screen

store_hours
	sta	timer+3

..dnet	cld

	bit	clock
	bpl	..notim

	jsr	prtime

..notim rts

updtim	ENDPROC


;-------------------------------------------------------------------------
;destroy left wall
raze_leftwal PROC
	lda	#$50-8		;now add walls
	sta	temp1

..loop2 lda	temp1
	sec
	sbc	#8		;move up
	sta	temp1
	cmp	#$18
	beq	..nxwal
	tay
	sta	rd_aux
	lda	scanlo,y	;lookup location to set
	sta	tdbl1
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04
	sta	tdbl1+1

	ldy	#17		;left wall
	lda	#$00
	sta	(tdbl1),y
	jmp	..loop2
..nxwal
	 jsr	  stamp_out_l_door

	rts
raze_leftwal ENDPROC

;-------------------------------------------------------------------------
;destroy right wall
raze_rghtwal PROC
	lda	#$50-8		;now add walls
	sta	temp1

..loop2 lda	temp1
	sec
	sbc	#8		;move up
	sta	temp1
	cmp	#$18
	beq	..nxwal
	tay
	sta	rd_aux
	lda	scanlo,y	;lookup location to set
	sta	tdbl1
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04
	sta	tdbl1+1

	lda	#$00
	ldy	#22		;right wall
	sta	(tdbl1),y

	jmp	..loop2
..nxwal
	 jsr	  stamp_out_r_door

	rts
raze_rghtwal ENDPROC


	END
