$chip(6502)

**********************************************
*					     *
*		Setup Room		     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	prmsec
	EXTERN	clear, draw, darken
	EXTERN	display(page0), workon, level(page0), side(page0)
	EXTERN	insrch, stunflg
	EXTERN	build, clock, chomp, dorksta
	EXTERN	leftwal,rghtwal,corribui,copy_e,copy_1,copy_2
	extern	stone(page0),tower16(page0)
	EXTERN	scanlo, scanhi, rd_main, wr_main, rd_aux, wr_aux
	extern	walkway,panel,dmap
	EXTERN	page1, page2
	extern	setrob,set_dhires
	extern	drkflg,bulbflg,holes,bombmem
	extern	door_opened_flag,stamp
	extern	rebuild

	PUBLIC	setroom, elevstf, copy_b,stamp_out_l_door,stamp_out_r_door

	SEG	temps
	double	punt
	single	xxtt

	SEG	maincode

copy_b	PROC

	sta	page1
	long	prmsec,copy_2
	move	workon,#$40
	long	prmsec,draw
	sta	page2
	long	prmsec,copy_1
	move	display,#0
	move	workon,#$20
	long	prmsec,draw
	rts

copy_b	ENDPROC

	extern	spr_1
setroom PROC

	sta	wr_aux		;disable robot sprites
	lda	#0
	sta	spr_1+15
	sta	spr_1+15+6
	sta	spr_1+15+12
	sta	spr_1+15+18
	sta	spr_1+15+24
	sta	spr_1+15+30
	sta	spr_1+15+36
	sta	spr_1+15+42

	sta	rd_main
	sta	wr_main

	 sta	  door_opened_flag	     ;"lock" doors

	move	display,#0
	move	workon,#$20

	lda	#0
	sta	insrch
;	sta	stunflg
	sta	clock
	sta	dorksta
	long	prmsec,clear

	lda	side
	beq	insd
	jsr	elevstf
	jmp	xit
insd
	lda	level
	cmp	#1
	bne	nund
	jsr	under
	jmp	xit
nund
	lda	tower16
	cmp	#$80
	beq	..last_tower_sk
	lda	level
	ora	tower16 	;set entered bit
	and	#$7e
	tax
	lda	walkway-2,x
	ora	#$20
	sta	walkway-2,x
	ldy	bulbflg
	beq	ckdrk
	and	#$ef
	sta	walkway-2,x
ckdrk
	and	#$10
	sta	drkflg

	lda	level
	ora	tower16
	and	#$7e
	tax
	lda	walkway-1,x
	and	#$f
	jmp	..dobuild
..last_tower_sk
	lda	#0
	sta	drkflg
	lda	#1
..dobuild
	tax
	long	prmsec,rebuild
	
	jsr	build
	long	prmsec,setrob
xit
	long	prmsec,copy_e

	rts

setroom ENDPROC

elevstf PROC

	move	clock,#$ff
	long	prmsec,corribui
	move	stone, #$60

	lda	side
	and	#$c0
	lbeq	over

	ldx	#0
	jsr	chomp

****

	lda	level
	cmp	#1
	lbeq	..bottm

	bit	side
	bmi	..lfsid

	ldx	level
	cpx	#13
	bne	..nacr

	ldx	#6	;rside
	jsr	chomp
;no right wall
	jmp	..nacr1
..nacr
;insert right wall
	long	prmsec,rghtwal
..nacr1
	ldx	#4	;lgrid
	jsr	chomp

	lda	tower16
	clc
	adc	level
	tax
	lda	walkway-2,x
	and	#$40
	beq	..nowa

	ldx	#2	;lside
	jsr	chomp
	jmp	..exit

..nowa	long	prmsec,leftwal ;insert left wall

	ldx	#16	;algridl
	jsr	chomp
	jmp	..exit

************

..lfsid ldx	level
	cpx	#13
	bne	..nacr2

	ldx	#2	;lside
	jsr	chomp

	jmp	..nacr3

..nacr2
;insert left wall
	long	prmsec,leftwal
..nacr3
	ldx	#8	;rgrid
	jsr	chomp

	lda	tower16
	clc
	adc	level
	tax
	lda	walkway-2,x
	and	#$80
	beq	..nowa2

	ldx	#6	;rside
	jsr	chomp
	jmp	..exit

..nowa2 long	prmsec,rghtwal ;insert right wall
	ldx	#18	;algridr
	jsr	chomp
	jmp	..exit

..bottm ldx	#2	;lside
	jsr	chomp
	ldx	#6	;rside
	jsr	chomp
	ldx	#10	;bottom
	jsr	chomp

..exit	jsr	panel
	sta	rd_aux
	sta	wr_aux
	lda	#0
	jsr	dmap
	sta	rd_main
	sta	wr_main

	rts

elevstf ENDPROC

under	PROC

	move	clock,#$ff
	move	stone,#$60

	ldx	#14
	jsr	chomp

	ldx	#24	;undr
	jsr	chomp
	jsr	panel
	ldx	#22*8+1
	sta	rd_aux
	lda	scanlo,x
	sta	punt
	lda	scanhi,x
	ora	stone
	sta	punt+1
	sta	rd_main
	ldy	#18
	lda	#$0c
	sta	(punt),y

	rts

under	ENDPROC

*********************************

over	PROC

	move	stone,#$60
	jsr	panel

	lda	level
	cmp	#1
	bne	..upper

	ldx	#26	;over
	jsr	chomp
	ldx	#22*8+1
	jmp	..ok

..upper ldx	#28	;upper
	jsr	chomp
	ldx	#22*8+1-12*4

..ok	ldy	#20
	lda	side
	cmp	#1
	bne	..ok2

	ldy	#16

..ok2	sta	rd_aux
	lda	scanlo,x
	sta	punt
	lda	scanhi,x
	ora	stone
	sta	punt+1
	sta	rd_main
	lda	#$40
	sta	(punt),y
	iny
	sta	wr_aux
	lda	#$01
	sta	(punt),y
	sta	wr_main



	 public   lockdr
lockdr
	 lda	  side
	 cmp	  #$01
	 bne	  ..build_for_right_side

	 long	  prmsec,rghtwal

	 jsr	  stamp_out_l_door

	 jmp	  ..alldone

..build_for_right_side
	 long	  prmsec,leftwal

	 jsr	  stamp_out_r_door

	 jmp	  ..alldone


..alldone

	rts

over	ENDPROC





stamp_out_l_door  proc
	 lda	  #16
	 sta	  ..xcoord
	 bne	  ..routine

stamp_out_r_door
	 lda	  #22
	 sta	  ..xcoord

..routine
	 lda	  #04
	 sta	  ..ycoord


..stlp
	 lda	  #$60
	 sta	  stone

	 ldy	  ..ycoord
	 ldx	  ..xcoord
	 lda	  #45
	 jsr	  stamp
	 inc	  ..ycoord
	 lda	  ..ycoord
	 cmp	  #$0a
	 bcc	  ..stlp


	 jsr	  copy_b


	 rts

..xcoord ds	  1
..ycoord ds	  1

stamp_out_l_door  endproc



	end
