$chip(6502)
$title(Impossible Mission 2)
$subtitle(Sprite routines)
$paginate
$indent=8

**********************************************
*		Sprite routines 	     *
**********************************************

	%include macro.inc
	%include secseg.inc

	EXTERN	scanlo, scanhi
	EXTERN	rd_aux, wr_aux, rd_main, wr_main
	EXTERN	sprtab, msktab, Shift0Lo
	EXTERN	workon
	EXTERN	sp_xpos, sp_ypos, sp_colr, sp_flag, sp_poin
	EXTERN	erbuff

	PUBLIC	draw, erasp

	SEG	temps

	double	screen1
	double	screen2
	double	point

	single	xp
	single	yp
	single	counts
	single	spnum
	single	dtacnt
	single	wko
	single	erpoin

buf	ds	3

	SEG	graph

draw	PROC

	move	wko,workon
	and	#$40
	sta	erpoin

	sta	rd_aux
	sta	wr_aux

	ldy	#0
	sty	spnum
	jmp	..skip

..nxspr add	erpoin,4
	add	spnum,6
	tay

..skip	ldx	erpoin
	lda	sp_flag,y
	beq	..nxspr
	bmi	..goon

	sta	rd_main
	sta	wr_main
	rts

..goon	sta	erbuff+3,x
	sta	..smod

	lda	sp_ypos,y
	sta	erbuff+1,x
	sta	yp

	lda	sp_poin,y
	sta	point
	lda	sp_poin+1,y
	sta	point+1

	lda	sp_colr,y
	and	#$7f
	ora	#high(sprtab)
	sta	..nr1f+2
	sta	..nr2f+2
	sta	..nr3f+2
	sta	..nr4f+2

	lda	sp_colr,y
	bpl	..left

	move	..bf2+1,#buf
	move	..bf1+1,#buf+2

	lda	sp_xpos,y
	and	#$03
	clc
	adc	#high(Shift0Lo)
	clc
	adc	#4
	jmp	..rom

..left	move	..bf1+1,#buf
	move	..bf2+1,#buf+2

	lda	sp_xpos,y
	and	#$03
	clc
	adc	#high(Shift0Lo)

..rom	sta	..sft1+2
	sta	..sft2+2
	sta	..sft3+2
	sta	..sft4+2

	lda	sp_xpos,y
	asl	a
	lda	sp_xpos,y
	ror	a
	and	#$fe
	sta	xp
	move	dtacnt,#1

	ldx	erpoin	; put info in erase buffer

	ldy	#0
	lda	(point),y
	sta	counts
	sta	erbuff+2,x
	lda	xp
	sta	erbuff+0,x

..loops ldy	yp
	cpy	#192
	bcs	..nxscn

	lda	scanlo,y
	sta	screen1
	lda	scanhi,y
	ora	wko		;workon
	sta	screen1+1

	ldy	dtacnt
	lda	(point),y
	tax
..sft1	lda	$ff00,x
..bf1	sta	buf
..sft2	lda	$ff80,x
	sta	buf+1
	iny
	lda	(point),y
	tax
..sft3	lda	$ff00,x
	ora	buf+1
	sta	buf+1
..sft4	lda	$ff80,x
..bf2	sta	buf+2

	move	..ldata+1,#buf
	ldy	xp

..lpm	cpy	#40
	bcs	..exits

..ldata lda	buf
	beq	..exits
	tax

	lda	(screen1),y
	and	msktab,x
..nr1f	ora	sprtab+$f00,x
	sta	(screen1),y
	iny
	lda	(screen1),y
	and	msktab+$80,x
..nr2f	ora	sprtab+$f80,x
	sta	(screen1),y

	sta	wr_main
	sta	rd_main

	lda	(screen1),y
	and	msktab+$80,x
..nr3f	ora	sprtab+$f80,x
	sta	(screen1),y
	dey
	lda	(screen1),y
	and	msktab,x
..nr4f	ora	sprtab+$f00,x
	sta	(screen1),y

	sta	wr_aux
	sta	rd_aux

..exits iny
	iny
	inc	..ldata+1
	lda	..ldata+1
	cmp	#buf+3
	bcc	..lpm

..nxscn lda	dtacnt
	clc
	adc	#2
	sta	dtacnt

..smod	inc	yp
	dec	counts
	lbne	..loops

	jmp	..nxspr

draw	ENDPROC

erasp	PROC

	move	wko,workon
	and	#$40
	tax

	sta	rd_aux
	sta	wr_aux

..nxspr lda	erbuff+3,x
;	bmi	..goon
	lbeq	..donxt
;	jmp	..out
..goon	sta	..smod

	lda	#0
	sta	erbuff+3,x

	lda	erbuff+1,x
	sta	yp
	lda	erbuff+0,x
	bpl	..ok1

	lda	#0

..ok1	cmp	#36
	bcc	..ok2

	lda	#34

..ok2	sta	xp
	lda	erbuff+2,x
	sta	counts

..loops ldy	yp
	cpy	#192
	bcs	..nxscn

	lda	scanlo,y
	sta	screen1
	sta	screen2
	lda	scanhi,y
	ora	#$60
	sta	screen1+1
	and	#$1f
	ora	wko
	sta	screen2+1

	ldy	xp
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y

	sta	rd_main
	sta	wr_main

	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y

	sta	rd_aux
	sta	wr_aux

..nxscn
..smod	inc	yp
	dec	counts
	bne	..loops

..donxt inx
	inx
	inx
	inx
	cpx	#$80
	beq	..out
	cpx	#$40
	beq	..out

	jmp	..nxspr

..out	sta	rd_main
	sta	wr_main
	rts

erasp	ENDPROC

	END
