$chip(6502)

**********************************************
*					     *
*	save room data (mem)		     *
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc

	extern	rd_main,wr_main,rd_aux,wr_aux
	extern	sfloors,objects,lifts,robots
	extern	holes,bombmem,room_p

	SEG	temps
	double	punt
	single	xxtt
	single	ilevel
	single	xtmp
	single	ytmp
	single	doneflg

	SEG	graph

	public	unbuild,rebuild
unbuild	proc
;copy back things to remember

	stx	ilevel
	ldx	ilevel
	lbeq	..xit

	dmovi	punt,SFLOORS

..loopd dadd	punt,455
	dex
	bne	..loopd

;copyback sfloors
	ldy	#8
..loopa
	dey
	lda	sfloors,y
	sta	(punt),y
	tya
	bne	..loopa

;copyback objects
	dadd	punt,9	;+nobjects

	ldy	#75
..loopb
	dey
	lda	objects,y
	sta	(punt),y
	tya
	bne	..loopb

;copyback lifts
	dadd	punt,76	;+nlifts
	ldy	#144
..loopc
	dey
	lda	lifts,y
	sta	(punt),y
	tya
	bne	..loopc

;robots
	dadd	punt,(145+50+1)	;lifts+niches+nniches+nrobots
	ldy	#24
..loope
	dey
	lda	robots,y
	sta	(punt),y
	tya
	bne	..loope
; bombs (?)

	sta	rd_aux
	sta	wr_aux

	dec	ilevel
	lda	ilevel

	asl	a
	asl	a
	asl	a
	sta	xxtt
	asl	a
	clc
	adc	xxtt
	tax

	ldy	#0

	lda	#24
	sta	xxtt

..bmblp
	lda	holes,y
	sta	bombmem,x
	inx
	iny
	dec	xxtt
	bne	..bmblp
	
	sta	rd_main
	sta	wr_main

..xit
	rts

unbuild	endproc

rebuild	proc

*** Build Stuff ***

	stx	ilevel
	
	dmovi	punt,room_p

..loopd dadd	punt,455
	dex
	bne	..loopd

	ldy	#0

..loopa lda	(punt),y
	sta	room_p,y
	iny
	bne	..loopa

	inc	punt+1

..loopb lda	(punt),y
	sta	room_p+$100,y
	iny
	cpy	#$c7
	bcc	..loopb

; bombs (?)

	sta	rd_aux
	sta	wr_aux

	dec	ilevel
	lda	ilevel
	
	asl	a
	asl	a
	asl	a
	sta	xxtt
	asl	a
	clc
	adc	xxtt
	tax

	ldy	#0

	lda	#24
	sta	xxtt

..bmblp
	lda	bombmem,x
	sta	holes,y
	inx
	iny
	dec	xxtt
	bne	..bmblp
	
	sta	rd_main
	sta	wr_main

	rts
	
rebuild	endproc

***************************************************************************
	public	clrhid,enthid
	extern	n_objects,MAXOBJECTS
clrhid	proc
;copy back things to remember
	ldx	#8
	stx	ilevel
..loopc
	ldx	ilevel
	dmovi	punt,n_objects

..loopd dadd	punt,455
	dex
	bne	..loopd

	ldy	#0
	lda	(punt),y
	sta	xxtt
	tax

..loopa
	iny
	iny
	iny
	lda	(punt),y	;get type
	iny
	iny

	cmp	#4		;lockout terminals and safes
	bcc	..termx
	lda	#0
	jmp	..termy
..termx	lda	#$ff
..termy
	sta	(punt),y
	dex
	bne	..loopa

	lda	#MAXOBJECTS
	sec
	sbc	xxtt
	beq	..no_unused_objs
	tax
	lda	#$ff
..loopb
	iny
	iny
	iny
	iny
	iny
	sta	(punt),y
	dex
	bne	..loopb

..no_unused_objs

	dec	ilevel
	bne	..loopc
	rts
clrhid	endproc


***************************************************************************
*passed - hidden value in A, tower16 value in y, and delta in x
	extern	walkway,objects
enthid	proc
	sta	xxtt
	stx	xtmp
	sty	ytmp
	
	ldx	ytmp
	lda	#0
	sta	doneflg
..scnlp
	lda	walkway+1,x
	and	#$f
	bne	..fndrm
..scnlp1
	inx
	inx
	txa
	and	#$f
	cmp	#12
	bne	..scnlp
	ldx	ytmp
	lda	doneflg
	bne	..scnlp
	lda	#$ff
	rts
	
..fndrm
	tay
	dmovi	punt,n_objects
..loopd dadd	punt,455
	dey
	bne	..loopd

	lda	#maxobjects
	sta	ilevel
..loopb
	dec	ilevel
	beq	..scnlp1
	iny
	iny
	iny
	iny
	iny
	lda	(punt),y
	bne	..loopb

	lda	#1
	sta	doneflg
	
	dec	xtmp
	bne	..loopb

	lda	xxtt
	sta	(punt),y
	lda	#0
	rts

enthid	endproc

	end
