$chip(6502)
$title(Impossible Mission 2)
$subtitle(Sprite routines)
$paginate
$indent=8

**********************************************
*		Sprite routines 	     *
**********************************************

	%include macro.inc
	%include secseg.inc

	EXTERN	scanlo, scanhi
	EXTERN	rd_aux, wr_aux, rd_main, wr_main
	EXTERN	sprtab, msktab, Shift0Lo
	extern	xsppoint

	PUBLIC	xdraw

	SEG	temps

	double	sppoint
	double	screen1
	double	screen2
	double	point

	single	spxofs
	single	spyofs

	single	atmp

	single	xp
	single	yp
	single	counts
	single	dtacnt

buf	ds	3

	SEG	graph

xdraw	PROC
	stx	spxofs
	sty	spyofs

	sta	rd_aux
	sta	wr_aux
	lda	xsppoint
	sta	sppoint
	lda	xsppoint+1
	sta	sppoint+1

	jmp	..skip

..nxspr
	ldy	#6
	lda	(sppoint),y	;get pointer to next sprite
	sta	atmp
	iny
	lda	(sppoint),y	;high byte
	beq	..endit
	sta	sppoint+1
	lda	atmp
	sta	sppoint

..skip
	ldy	#3		;check sprite flag
	lda	(sppoint),y
	beq	..nxspr
	bmi	..goon
..endit				;non-negative non-zero exits
	sta	rd_main
	sta	wr_main
	rts

..goon
	sta	..smod

	ldy	#1		;extract y coordinate
	lda	(sppoint),y
	clc
	adc	spyofs
	sta	yp

	ldy	#4		;extract pointer to image from structure
	lda	(sppoint),y
	sta	point
	iny
	lda	(sppoint),y
	sta	point+1

	ldy	#2		;get color/horizontal mirroring
	lda	(sppoint),y
	and	#$7f
	ora	#high(sprtab)
	sta	..nr1f+2
	sta	..nr2f+2
	sta	..nr3f+2
	sta	..nr4f+2

	lda	(sppoint),y
	bpl	..left

	move	..bf2+1,#buf
	move	..bf1+1,#buf+2

	ldy	#0
	lda	(sppoint),y
	clc
	adc	spxofs
	and	#$03
	clc
	adc	#high(Shift0Lo)
	clc
	adc	#4
	jmp	..rom

..left	move	..bf1+1,#buf
	move	..bf2+1,#buf+2

	ldy	#0
	lda	(sppoint),y		;get x coordinate
	clc
	adc	spxofs
	and	#$03
	clc
	adc	#high(Shift0Lo)

..rom	sta	..sft1+2
	sta	..sft2+2
	sta	..sft3+2
	sta	..sft4+2

	lda	(sppoint),y
	clc
	adc	spxofs
	sta	atmp
	asl	a
	lda	atmp
	ror	a
	and	#$fe
	sta	xp
	move	dtacnt,#1

	ldy	#0
	lda	(point),y
	sta	counts
	lda	xp

..loops ldy	yp
	cpy	#192
	bcs	..nxscn

	lda	scanlo,y
	sta	screen1
	lda	scanhi,y
	ora	#$60		;workon
	sta	screen1+1

	ldy	dtacnt
	lda	(point),y
	tax
..sft1	lda	$ff00,x
..bf1	sta	buf
..sft2	lda	$ff80,x
	sta	buf+1
	iny
	lda	(point),y
	tax
..sft3	lda	$ff00,x
	ora	buf+1
	sta	buf+1
..sft4	lda	$ff80,x
..bf2	sta	buf+2

	move	..ldata+1,#buf
	ldy	xp

..lpm	cpy	#40
	bcs	..exits

..ldata lda	buf
	beq	..exits
	tax

	lda	(screen1),y
	and	msktab,x
..nr1f	ora	sprtab+$f00,x
	sta	(screen1),y
	iny
	lda	(screen1),y
	and	msktab+$80,x
..nr2f	ora	sprtab+$f80,x
	sta	(screen1),y

	sta	wr_main
	sta	rd_main

	lda	(screen1),y
	and	msktab+$80,x
..nr3f	ora	sprtab+$f80,x
	sta	(screen1),y
	dey
	lda	(screen1),y
	and	msktab,x
..nr4f	ora	sprtab+$f00,x
	sta	(screen1),y

	sta	wr_aux
	sta	rd_aux

..exits iny
	iny
	inc	..ldata+1
	lda	..ldata+1
	cmp	#buf+3
	bcc	..lpm

..nxscn lda	dtacnt
	clc
	adc	#2
	sta	dtacnt

..smod	inc	yp
	dec	counts
	lbne	..loops

	jmp	..nxspr

xdraw	ENDPROC

	END
